<script>
    let default_bid_data = {
        names: {},
        objects: {},
        rpc: {
            get_offers_by_item: []
        }
    };

    //parameter offers: array of offer objects
    export /**
     * @type {
            {
                names: any;
                objects: any;
                rpc: {
                    get_offers_by_item: Array<any>;
                }
            }
        }
     */
    let data;

    let bid_data =
        data != null && data.rpc != null && data.rpc.get_offers_by_item.length != 0
            ? data
            : default_bid_data;

    //parameter offers: array of offer objects
    export /**
     * @type {Array<any>}
     */
    let offers = bid_data.rpc.get_offers_by_item;

    //Line 1: Reads "Current status", or "Current bid", or "Buy now for" (if for sale at a fixed price only)
    let line1 = 'Current Status';

    //Line 2: Displays "Not available for sale", else displays the current bid amount, else the buy now price
    let line2 = 'Invalid';

    //Line 3: Displays "Or buy it now for [amount]" (except when the buy now price is shown on line 2) in a smaller font size.
    let line3 = '';

    //Line 4: Displays "Sales ends at [date and time]"
    let line4 = '';

    //private data to help render component state data
    let assetId = '';
    let precision = 0;
    let symbol = '';
    let disableButton = true;

    function formatDateTime(dateTime) {
        try {
            return `${dateTime.split('T')[1].slice(0, 5)} on ${dateTime.split('T')[0]}`;
        } catch (err) {
            return '<invalid date>';
        }
    }

    function formatPrice(amount = 0, precision = 0, symbol = '') {
        let strAmount = amount.toString();
        let truncatedAmount = strAmount.substring(0, strAmount.length - precision);
        let decimalAmount = strAmount.substring(strAmount.length - precision);
        return `${truncatedAmount}.${decimalAmount} ${symbol}`;
    }

    function setTopBid(offers) {
        //find sale offer object in offers
        let sellOffer = offers.find((offer) => offer.buying_item === false);

        //state 1: item is not for sale, i.e. sell offer obj not found.
        if (!sellOffer) {
            line1 = 'Current Status';
            line2 = 'Not available for sale';
            line3 = '';
            line4 = '';
            return;
        }
        //state 2: item is for sale at a fixed price
        if (sellOffer && sellOffer.maximum_price.amount == sellOffer.minimum_price.amount) {
            assetId = sellOffer.maximum_price.asset_id;
            precision = bid_data.objects[assetId].precision;
            symbol = bid_data.objects[assetId].symbol;
            disableButton = false;

            line1 = 'Buy now for';
            line2 = formatPrice(sellOffer.maximum_price.amount, precision, symbol);
            line3 = '';
            line4 = `Sale ends at: ${formatDateTime(sellOffer.offer_expiration_date)}`;
            return;
        }
        //state 3: item is for sale with a min/max price, and has bids
        if (
            'bidder' in sellOffer &&
            'bid_price' in sellOffer &&
            sellOffer.bidder != null &&
            sellOffer.bid_price != null
        ) {
            assetId = sellOffer.bid_price.asset_id;
            precision = bid_data.objects[assetId].precision;
            symbol = bid_data.objects[assetId].symbol;
            disableButton = false;

            line1 = 'Current Bid';
            line2 = formatPrice(sellOffer.bid_price.amount, precision, symbol);
            line3 = `Or buy it now for: ${formatPrice(
                sellOffer.maximum_price.amount,
                precision,
                symbol
            )}`;
            line4 = `Sale ends at: ${formatDateTime(sellOffer.offer_expiration_date)}`;
            disableButton = false;
            return;
        }
        //state 4: item is for sale with a min/max price but no bids
        else {
            assetId = sellOffer.maximum_price.asset_id;
            precision = bid_data.objects[assetId].precision;
            symbol = bid_data.objects[assetId].symbol;
            disableButton = false;

            line1 = 'Minimum bid';
            line2 = formatPrice(sellOffer.minimum_price.amount, precision, symbol);
            line3 = `Or buy it now for: ${formatPrice(
                sellOffer.maximum_price.amount,
                precision,
                symbol
            )}`;
            line4 = `Sale ends at: ${formatDateTime(sellOffer.offer_expiration_date)}`;
            disableButton = false;
        }
    }

    //set component state data if data is not null and offers exist
    if (Object.keys(data).length > 0 && offers) setTopBid(offers);
</script>

<div>
    <h1 class="text-md text-slate-900">{line1}:</h1>
    <h2 class="text-xl text-slate-900 mb-5 font-bold">{line2}</h2>
    {#if line3 != ''}
        <h3 class="text-md mb-2">{line3}</h3>
    {/if}
    <h4 class="text-md text-slate-600">{line4}</h4>
    <button
        class="bg-sky-500 rounded-md px-10 py-3 text-md my-4 text-white font-reg"
        disabled={disableButton}>Bid/ Make an offer</button
    >
</div>
